summaryrefslogtreecommitdiffstats
path: root/13.0-rc/apache/entrypoint.sh
diff options
context:
space:
mode:
authorTilo Spannagel <development@tilosp.de>2018-04-19 13:13:36 +0200
committerTilo Spannagel <development@tilosp.de>2018-04-19 13:13:36 +0200
commit50f68d6c4e6ff4e65935e36b2a99aac3ecf4bf20 (patch)
tree0dc2bc4563b69a4c5c92b92e073616e8a5a0a914 /13.0-rc/apache/entrypoint.sh
parent5ddd03aa501a53d609ec4f8de3add575fc10f5ce (diff)
Diffstat (limited to '13.0-rc/apache/entrypoint.sh')
-rwxr-xr-x13.0-rc/apache/entrypoint.sh62
1 files changed, 62 insertions, 0 deletions
diff --git a/13.0-rc/apache/entrypoint.sh b/13.0-rc/apache/entrypoint.sh
new file mode 100755
index 00000000..8f3ac087
--- /dev/null
+++ b/13.0-rc/apache/entrypoint.sh
@@ -0,0 +1,62 @@
+#!/bin/sh
+set -eu
+
+# version_greater A B returns whether A > B
+version_greater() {
+ [ "$(printf '%s\n' "$@" | sort -t '.' -n -k1,1 -k2,2 -k3,3 -k4,4 | head -n 1)" != "$1" ]
+}
+
+# return true if specified directory is empty
+directory_empty() {
+ [ -z "$(ls -A "$1/")" ]
+}
+
+run_as() {
+ if [ "$(id -u)" = 0 ]; then
+ su - www-data -s /bin/sh -c "$1"
+ else
+ sh -c "$1"
+ fi
+}
+
+installed_version="0.0.0.0"
+if [ -f /var/www/html/version.php ]; then
+ # shellcheck disable=SC2016
+ installed_version="$(php -r 'require "/var/www/html/version.php"; echo implode(".", $OC_Version);')"
+fi
+# shellcheck disable=SC2016
+image_version="$(php -r 'require "/usr/src/nextcloud/version.php"; echo implode(".", $OC_Version);')"
+
+if version_greater "$installed_version" "$image_version"; then
+ echo "Can't start Nextcloud because the version of the data ($installed_version) is higher than the docker image version ($image_version) and downgrading is not supported. Are you sure you have pulled the newest image version?"
+ exit 1
+fi
+
+if version_greater "$image_version" "$installed_version"; then
+ if [ "$installed_version" != "0.0.0.0" ]; then
+ run_as 'php /var/www/html/occ app:list' | sed -n "/Enabled:/,/Disabled:/p" > /tmp/list_before
+ fi
+ if [ "$(id -u)" = 0 ]; then
+ rsync_options="-rlDog --chown www-data:root"
+ else
+ rsync_options="-rlD"
+ fi
+ rsync $rsync_options --delete --exclude /config/ --exclude /data/ --exclude /custom_apps/ --exclude /themes/ /usr/src/nextcloud/ /var/www/html/
+
+ for dir in config data custom_apps themes; do
+ if [ ! -d "/var/www/html/$dir" ] || directory_empty "/var/www/html/$dir"; then
+ rsync $rsync_options --include "/$dir/" --exclude '/*' /usr/src/nextcloud/ /var/www/html/
+ fi
+ done
+
+ if [ "$installed_version" != "0.0.0.0" ]; then
+ run_as 'php /var/www/html/occ upgrade --no-app-disable'
+
+ run_as 'php /var/www/html/occ app:list' | sed -n "/Enabled:/,/Disabled:/p" > /tmp/list_after
+ echo "The following apps have beed disabled:"
+ diff /tmp/list_before /tmp/list_after | grep '<' | cut -d- -f2 | cut -d: -f1
+ rm -f /tmp/list_before /tmp/list_after
+ fi
+fi
+
+exec "$@"